#include "Timer.h"
#include <avr/interrupt.h>


volatile uint8_t Timer[TIMERANZAHL];

inline void Timer_set(uint8_t nummer, uint8_t Zeit)
{
	Timer[nummer-1]=Zeit;
}

inline uint8_t Timer_done(uint8_t nummer)
{
	if ( Timer[nummer-1]==0 )
		return 1;
	return 0;
}

#if defined(__AVR_ATmega16__)
	ISR(TIMER0_COMP_vect)
#elif defined(__AVR_ATmega88__)
	ISR(TIMER0_COMPA_vect)
#endif
{
	for (uint8_t i=0;i<TIMERANZAHL;i++)
	{
		if ( (Timer[i]<=250) && (Timer[i]>0) )
			Timer[i]--;
	}
	
}

inline void ms_Timer_init()
{
	for (uint8_t i=0;i<TIMERANZAHL;i++)
	{
		Timer[i]=TIMER_AUS;
	}
#if defined(__AVR_ATmega16__)
	TCCR0 = (1<<WGM01) | (1<<CS02);
	OCR0 = F_CPU/(1000L*256L);
	TIMSK |= (1<<OCIE0);
#elif defined(__AVR_ATmega88__)
	//TCCR0A = (1<<WGM00);
	TCCR0B = (1<<WGM01)|(1<<CS01);
	OCR0A = F_CPU/(1000L*8L);
	TIMSK0 |= (1<<OCIE0A);
#endif
	
}