#include "steuerung.h"
#include "Timer.h"
#include <avr/io.h>
#include <util/delay.h>

void warten1(void);
void zufahren(void);
void warten2(void);
void halten(void);
void auffahren(void);

void abbruch(void);

void (*Funktion)(void);

void warten1(void)
{
	//
	//neuer ist hier der Schlitten eingefahren Kontakt
	//
	uint8_t neuer = ( ~PINC & (1<<PC4) );
	static uint8_t alter = 0;
	static uint8_t alter_erkannter = 123;
	Timer_set(1,20);
	
	//
	//Sorgt dafr das mindestens einmal der Schlitten reingefahren werden muss,
	//damit der Stempel runterfhrt. also nach den Neustart.
	// 
	if (alter_erkannter == 123)
		alter_erkannter = neuer;
	
	if (alter == neuer)
	{
		if ( !alter_erkannter && neuer )
			Funktion = zufahren;
		alter_erkannter = neuer;
	}
	alter = neuer;
}

void zufahren(void)
{
	PORTD |= (1<<PD5);
	Funktion = warten2;
	
}

void warten2(void)
{
	//
	//neuer ist hier der Stempel unten Kontakt.
	//
	uint8_t neuer = ( ~PINB & (1<<PB1) );
	static uint8_t alter = 0;
	
	if ( alter && neuer )
	{
		Funktion = halten;
		Timer_set(2,HALTEZEIT);
	}
	alter = neuer;
}

void halten(void)
{
	if ( Timer_done(2) )
	{
		Timer_set(2, TIMER_AUS);
		Funktion = auffahren;
	}
}

void auffahren(void)
{
	PORTD &= ~(1<<PD5);
	Funktion = warten1;
}

void abbruch(void)
{
	Funktion = auffahren;
}

void steuerung_init(void)
{
	DDRB &= ~(1<<PB1);		//Eingang Sensor
	PORTB |= (1<<PB1);		//PULL-UP setzen
	
	DDRC &= ~(1<<PC4);		//ON Eingang
	PORTC |= (1<<PC4);		//PUll-UP
	
	DDRC &= ~(1<<PC5);		//Abbruch Eingang
	PORTC |= (1<<PC5);		//Pull-UP
	
	
	DDRD |= (1<<PD5);		//Ausgang Magnetventil
	Funktion = warten1;
}

void steuerung(void)
{
	Funktion();
	if ( ~PINC & (1<<PC5) )
		abbruch();
}
